#version 330                                                                         
                                                                                     
layout(points) in;                                                                   
layout(points) out;                                                                  
layout(max_vertices = 30) out;                                                       
                                                                                     
in float Type0[];                                                                    
in vec3 Position0[];                                                                 
in vec3 Velocity0[];                                                                 
in float Age0[]; 
in vec3 Acceleration0[];                                                                     
in float Lifetime0[];            
		                                                                             
out float Type1;                                                                     
out vec3 Position1;                                                                  
out vec3 Velocity1;                                                                  
out float Age1;     
out vec3 Acceleration1;    
out float Lifetime1;                                                                  
                                                                                     
uniform float deltaT;                                                      
uniform float time;                                                                                                                                                                
uniform float systemLifeTime; 
uniform vec4 rnd;     
uniform vec3 gravity;                                                                                            
                                                                                     
#define PARTICLE_TYPE_LAUNCHER 0.0f                                                  
#define PARTICLE_TYPE_NORMAL 1.0f       
                                                

void main(){                             
                                                                                     
    if (Type0[0] == PARTICLE_TYPE_LAUNCHER) { 
	                                   
        if (Age0[0] >= Lifetime0[0]){
			return;                   
		}   

		vec3 force = vec3(0.0,0.0,0.0);
		if (Position0[0].y < 0.03) {
			force = vec3(0.0, 0.009,0.0);
		}
		if (Position0[0].y > 0.05 && Position0[0].y > 0.09) {
			force = vec3(0.0, -0.0001,0.0);
		}
		                        
            Type1 = PARTICLE_TYPE_LAUNCHER;    
			Acceleration1 = Acceleration0[0]; //mal egal, bei uns atm nur gravitation die rechne ich gleich dazu   
			Lifetime1 = Lifetime0[0];                        
			Velocity1 = Velocity0[0] + vec3(0.0,-0.001,0.0) + Acceleration1 + force;                                                                                                                                    
			Position1 = Position0[0] + Velocity1*deltaT;               
			Age1 = Age0[0] + deltaT;                                                           
			EmitVertex();                                                            
			EndPrimitive(); 
		                                                                                                                                                                                 
    } 
 
}                                    
