#version 330
in vec2 UV;

//out vec3 color;

uniform sampler2D renderedTexture;
uniform sampler2D alphaTexture;
uniform vec2 uShift;
uniform int multiply; 

const int gaussRadius = 11;
const float gaussFilter[gaussRadius] = float[gaussRadius](
	0.0402,0.0623,0.0877,0.1120,0.1297,0.3362,0.1297,0.1120,0.0877,0.0623,0.0402
);

out vec3 colorRender;
out vec3 colorAlpha;


void main(){
	colorRender = texture( renderedTexture, UV).rgb ;

	vec2 texCoord = UV - float(int(gaussRadius/2)) * uShift;
	vec3 color = vec3(0.0, 0.0, 0.0); 
	for (int i=0; i<gaussRadius; ++i) { 
		color += gaussFilter[i] * texture2D(alphaTexture, texCoord).rgb;
		texCoord += uShift;
	}
	colorAlpha = vec3(color);
	
   
  if(multiply == 1){
	 colorRender = colorRender+colorAlpha; 
  }
   //colorRender=colorAlpha;  
	
	
}