#version 150

// from OpenGL SuperBible & http://www.lighthouse3d.com/tutorials/glsl-tutorial/the-normal-matrix/

in vec3 normal; 
in vec3 position;

uniform mat4 VP;
uniform mat4 Camera;
uniform mat4 View;
uniform mat4 modelMatrix;

uniform vec4 wvLightPosition;

smooth out vec3 worldNormal;
smooth out vec3 worldLightDir;
out vec3 viewVector;

out vec4 WS_pos;

void main()
{
	// Get surface normal in eye coordinates
	worldNormal = (transpose(inverse(View * modelMatrix)) * vec4(normal, 0)).xyz; 

	// Get vertex position in eye coordinates
    vec4 vPosition4 = View * modelMatrix * vec4(position, 1);
    //vec3 vPosition3 = vPosition4.xyz / vPosition4.w;

	// Get vector to light source
	vec4 vLightPosition =  View * wvLightPosition;
    worldLightDir = normalize(vLightPosition - vPosition4).xyz;
	
	// Don't forget to transform the geometry!
	vec4 localPosition = vec4(position, 1);
    gl_Position = VP * modelMatrix * localPosition;	

	viewVector = (-vPosition4).xyz;
	
	WS_pos = modelMatrix * vec4(position, 1.0);
}
